package com.zmofun.erase;

/*
	Copyright zmofun           All rights reserved!
	http://www.zmofun.com
	2000.1.14        TurboC++2.0

  zmofun@163.com
  2020.10.28～10.29    移植到JAVA版本
	
*/
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

public class Game extends JFrame implements ActionListener, KeyListener {

	/**
	 * 
	 */
	private static final long serialVersionUID = -915706190696233056L;

	GameBox[] box = new GameBox[2];
	JMenuBar menu;
	int[] keya = { 87, 83, 65, 68 };// 上下左右w,s,a,d
	int[] keyb = { 38, 40, 37, 39 };// 上下左右up,down,left,right

	public Game() {
		box[0] = new GameBox();
		box[1] = new GameBox();
		box[0].init(105, 50, 13, 16, 30, 40, keya);
		box[1].init(5, 50, 13, 16, 30, 240, keyb);

		Container c = getContentPane();
		c.setLayout(new GridLayout(1, 2, 5, 0));

		menu = new JMenuBar();
		setJMenuBar(menu);
		JMenu game = new JMenu("游戏");
		JMenuItem newgame = game.add("开始");
		newgame.addActionListener(new StartGameListener(box[0]));
		newgame.addActionListener(new StartGameListener(box[1]));
		JMenuItem pause = game.add("暂停");
		pause.addActionListener(new PauseGameListener(box[0]));
		pause.addActionListener(new PauseGameListener(box[1]));
		JMenuItem goOn = game.add("继续");
		goOn.addActionListener(new GoOnGameListener(box[0]));
		goOn.addActionListener(new GoOnGameListener(box[1]));
		JMenuItem exit = game.add("退出");
		exit.addActionListener(new ExitGameListener());
		JMenu help = new JMenu("帮助");
		JMenuItem about = help.add("关于");
		about.addActionListener(new AboutListener());
		menu.add(game);
		menu.add(help);

		setLocationRelativeTo(null);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(700, 560);

		c.add(box[0]);
		c.add(box[1]);

		setTitle("Erase");
		setVisible(true);
		setResizable(false);
		addKeyListener(this);
	}

	@Override
	public void keyPressed(KeyEvent e) {
		box[0].play(e.getKeyCode());
		box[1].play(e.getKeyCode());
	}

	@Override
	public void keyReleased(KeyEvent arg0) {
		System.out.println(arg0.getKeyCode());
	}

	@Override
	public void keyTyped(KeyEvent arg0) {

	}

	@Override
	public void actionPerformed(ActionEvent e) {

	}

}

class ExitGameListener implements ActionListener {
	public void actionPerformed(ActionEvent e) {
		System.exit(0);
	}
}

class StartGameListener implements ActionListener {

	GameBox gameBox;

	public StartGameListener(GameBox gameBox) {
		this.gameBox = gameBox;
	}

	public void actionPerformed(ActionEvent e) {
		gameBox.start = true;
		gameBox.pause = false;
	}
}

class PauseGameListener implements ActionListener {

	GameBox gameBox;

	public PauseGameListener(GameBox gameBox) {
		this.gameBox = gameBox;
	}

	public void actionPerformed(ActionEvent e) {
		gameBox.pause = true;
	}
}

class GoOnGameListener implements ActionListener {

	GameBox gameBox;

	public GoOnGameListener(GameBox gameBox) {
		this.gameBox = gameBox;
	}

	public void actionPerformed(ActionEvent e) {
		gameBox.pause = false;
	}
}

class AboutListener implements ActionListener {
	public void actionPerformed(ActionEvent e) {
		JOptionPane.showMessageDialog(null, "www.zmofun.cn\nplayer1:a|w|s|d\nplayer2:left|up|down|right", "这是什么？",
				JOptionPane.PLAIN_MESSAGE);
	}
}
