package com.zmofun.erase;

/*
	Copyright zmofun           All rights reserved!
	http://www.zmofun.com
	2000.1.14        TurboC++2.0

  zmofun@163.com
  2020.10.28～10.29    移植到JAVA版本
	
*/
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JPanel;
import javax.swing.Timer;

public class GameBox extends JPanel {

	/**
	 *
	 */
	private static final long serialVersionUID = -797261276505775802L;
	boolean start;
	boolean pause;
	int px, py, boxwidth, boxperline, boxpercolumn, keyup, keydown, keyleft, keyright;
	int pxmess;
	int score, level, speed, layer;
	int begin;
	int[] controlkey = new int[4];
	long inter;
	Shape curshape;
	Timer timer;

	int[][] stick = new int[41][22];

	public GameBox() {
		timer = new Timer(200, new TimerListener());
		timer.start();
	}

	int canmove(int direct) {
		int i, j;
		switch (direct) {
			case 1:
				for (j = 0; j < 5; j++)
					for (i = 0; i < 5; i++)
						if (curshape.s[i][j] > 0 && stick[curshape.l + i][curshape.c - 1 + j] > 0)
							return 0;
				break;
			case 2:
				for (j = 4; j >= 0; j--)
					for (i = 0; i < 5; i++)
						if (curshape.s[i][j] > 0 && stick[curshape.l + i][curshape.c + 1 + j] > 0)
							return 0;
				break;
			case 3:
				for (i = 4; i >= 0; i--)
					for (j = 0; j < 5; j++)
						if (curshape.s[i][j] > 0 && stick[curshape.l + 1 + i][curshape.c + j] > 0)
							return 0;
				break;
			default:
				break;
		}
		return 1;
	}

	int gameconfiged(int key) {
		if (key == 0)
			return 0;
		if (key == controlkey[0]) {
			level = (level + 1) % 4;
		}
		if (key == controlkey[1])
			return 1;
		if (key == controlkey[2]) {
			speed = (speed + 1) % 10;
		}
		if (key == controlkey[3]) {
			layer = (layer + 1) % 10;
		}
		repaint();
		return 0;
	}

	long clock() {
		return System.currentTimeMillis();
	}

	void play(int key) {
		if (start && begin == 0) {
			if (gameconfiged(key) > 0)
				gamebegin();
			return;
		}
		if (key == controlkey[0])
			if (canrotate() > 0)
				curshape.rotate();
		if (key == controlkey[2])
			if (canmove(1) > 0)
				curshape.move(1);
		if (key == controlkey[3])
			if (canmove(2) > 0)
				curshape.move(2);
		if (key == controlkey[1])
			if (canmove(3) > 0)
				curshape.move(3);
		if (clock() - inter > 300 - 20 * speed) {
			if (canmove(3) > 0) {
				inter = clock();
				curshape.move(3);
			} else {
				if (gameover() > 0)
					begin = 0;
				else {
					curshape.getnextsh(px + boxwidth * (boxperline / 2 - 3), py, 0,
							boxperline / 2 - 2, level);
				}
			}
		}
		repaint();
	}

	public void init(int x, int y, int boxw, int w, int h, int messx, int[] keyin) {
		// this.setLocation(x, y);
		// this.setBounds(x, y, w, h);
		int i, j;
		px = x;
		py = y;
		boxwidth = boxw;
		boxperline = w;
		boxpercolumn = h;
		pxmess = messx;
		level = 1;
		score = 0;
		speed = 1;
		layer = 3;
		inter = clock();
		begin = 0;
		for (i = 0; i < boxpercolumn; i++)
			for (j = 1; j < boxperline + 1; j++)
				stick[i][j] = 0;
		for (i = 0; i < boxpercolumn + 1; i++) {
			stick[i][0] = 1;
			stick[i][boxperline + 1] = 1;
		}
		for (j = 0; j < boxperline + 2; j++)
			stick[boxpercolumn][j] = 1;
		for (i = 0; i < 4; i++)
			controlkey[i] = keyin[i];
		curshape = new Shape();
		curshape.init(px + boxwidth * (boxperline / 2 - 2), py, 5 * boxwidth, 0, boxperline / 2 - 2, level);
	}

	void paintScore(Graphics g) {
		String mess;
		mess = String.format("%d", score);
		bar(g, px + 30, py - 20, px + 80, py - 20 + 10);
		outtextxy(g, px + 30, py - 20, mess);
	}

	void outtextxy(Graphics g, int x, int y, String text) {
		g.setFont(Font.getFont("隶书"));
		g.setColor(Color.BLACK);
		g.drawString(text, x, y);
	}

	void bar3D(Graphics g, int x, int y, int x2, int y2) {
		g.setColor(Color.RED);
		g.draw3DRect(x, y, x2 - x, y2 - y, true);
	}

	void bar(Graphics g, int x, int y, int x2, int y2) {
		g.setColor(Color.WHITE);
		g.drawRect(x, y, x2 - x, y2 - y);
	}

	void paintMessage(Graphics g) {
		String mess;

		outtextxy(g, 10, 460, "Source code can download from http://www.zmofun.cn!");
		outtextxy(g, pxmess, py + 20, "LEVEL");
		mess = String.format("%d", level);
		bar(g, pxmess + 20, py + 40, pxmess + 20 + 40, py + 50);
		outtextxy(g, pxmess + 20, py + 40, mess);

		outtextxy(g, pxmess, py + 60, "SPEED");
		mess = String.format("%d", speed);
		bar(g, pxmess + 20, py + 80, pxmess + 20 + 40, py + 90);
		outtextxy(g, pxmess + 20, py + 80, mess);

		outtextxy(g, pxmess, py + 100, "LAYER");
		mess = String.format("%d", layer);
		bar(g, pxmess + 20, py + 120, pxmess + 20 + 40, py + 130);
		outtextxy(g, pxmess + 20, py + 120, mess);
		paintScore(g);
	}

	void gamebegin() {
		int i, j, b;
		int[] randnum = { 1, 1, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 1, 0, 1, 0, 0, 1, 0, 1, 0,
				0, 0, 1, 0, 1, 0, 1, 0, 1, 0,
				0, 1, 0, 0, 1, 0, 1, 0, 0, 1,
				0, 1, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 0, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
				0, 1, 0, 0, 1, 0, 0, 1, 0, 0,
				1, 0, 0, 1, 0, 0, 1, 0, 1, 0,
				1, 0, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
				0, 1, 0, 0, 1, 0, 0, 1, 0, 0,
				1, 1, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 1, 0, 1, 0, 0, 1, 0, 1, 0,
				0, 0, 1, 0, 1, 0, 1, 0, 1, 0,
				1, 1, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 1, 0, 1, 0, 0, 1, 0, 1, 0,
				0, 0, 1, 0, 1, 0, 1, 0, 1, 0,
				0, 1, 0, 0, 1, 0, 1, 0, 0, 1,
				0, 1, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 0, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
				0, 1, 0, 0, 1, 0, 0, 1, 0, 0,
				1, 0, 0, 1, 0, 0, 1, 0, 1, 0,
				0, 1, 0, 0, 1, 0, 1, 0, 0, 1,
				0, 1, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 0, 0, 1, 0, 1, 0, 1, 0, 1,
				1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
				0, 1, 0, 0, 1, 0, 0, 1, 0, 0,
				1, 0, 0, 1, 0, 0, 1, 0, 1, 0,
				1, 0, 1, 0, 1, 0, 1, 0, 1, 0 };

		for (i = 0; i < boxpercolumn - 1; i++) // clear game box's stick
			for (j = 1; j < boxperline + 1; j++)
				stick[i][j] = 0;

		for (i = 0; i < layer; i++)
			for (j = 1; j < boxperline + 1; j++) {
				b = ((int) (Math.random() * 100)) % 20 + i;
				stick[boxpercolumn - 1 - i][j] = randnum[b + j];
			}
		// paintstick();
		curshape.getnextsh(px + boxwidth * (boxperline / 2 - 3), py, 0, boxperline / 2 - 2, level);
		score = 0;
		// showscore();
		begin = 1;

		repaint();
	}

	int canrotate() {
		int i, j;
		int[][] t = new int[5][5];
		for (i = 0; i < 5; i++)
			for (j = 0; j < 5; j++) {
				t[i][j] = curshape.s[4 - j][i];
				if (t[i][j] > 0 && stick[curshape.l + i][curshape.c + j] > 0)
					return 0;
			}
		return 1;
	}

	void paintStick(Graphics g) {
		int i, j;
		for (i = 0; i < boxpercolumn; i++)
			for (j = 1; j < boxperline + 1; j++)
				if (stick[i][j] > 0)
					bar3D(g, px + boxwidth * (j - 1) + 1, py + boxwidth * i + 1,
							px + boxwidth * j - 1, py + boxwidth * (i + 1) - 1);
				else
					bar(g, px + boxwidth * (j - 1) + 1, py + boxwidth * i + 1,
							px + boxwidth * j - 1, py + boxwidth * (i + 1) - 1);
	}

	void addscore() {
		int i, j, line, ln, high = 0, addspeed;
		int[] t = new int[40];
		line = 0;
		for (i = boxpercolumn - 1; i >= 0; i--) {
			t[i] = 0;
			for (j = 1; j < boxperline + 1; j++)
				t[i] += stick[i][j];
			if (t[i] > 0)
				high = i;
			if (t[i] == boxperline) {
				line++;
				t[i] = 1;
			} else
				t[i] = 0;
		}
		for (i = boxpercolumn - 1; i >= high; i--) {
			if (t[i] > 0) {
				ln = i - 1;
				while (t[ln] > 0)
					ln--;
				for (j = 1; j < boxperline + 1; j++) {
					stick[i][j] = stick[ln][j];
					stick[ln][j] = 0;
				}
				t[ln] = 1;
			}
		}
		// paintstick();
		addspeed = score / 1000;
		if (line > 3)
			score += 2 * line * 100;
		else
			score += line * 100;
		if (addspeed != score / 1000)
			speed = (speed + 1) % 10;
		// showscore();
		repaint();
	}

	int gameover() {
		int i, j;
		if (curshape.l < 1)
			return 1;
		else {
			for (i = 0; i < 5; i++)
				for (j = 0; j < 5; j++)
					if (curshape.s[i][j] > 0)
						stick[i + curshape.l][curshape.c + j] = curshape.s[i][j];
		}
		addscore();
		return 0;
	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		// g.clearRect(this.getX(), this.getY(), this.getWidth(), this.getHeight());

		g.setColor(Color.RED);
		g.drawRect(px, py, boxperline * boxwidth, boxpercolumn * boxwidth + 1);

		paintStick(g);
		// paintScore(g);
		paintMessage(g);
		curshape.paint(g);
		curshape.paintnext(g, pxmess - 10, py + 200);
	}

	class TimerListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {

			if (!start)
				return;
			if (pause)
				return;
			play(1); // 非0值，不要与controlkey重合
			repaint();
		}
	}
}