package com.zmofun.neterase;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;

public class Client {
	private Socket clientSocket;
	private ObjectOutputStream os;
	private ObjectInputStream is;
	String myName;
	String fellowName;
	PlayInfo me;
	PlayInfo fellow;
	Date lastReadTime;
	
	GameBox boxMe;
	GameBox boxFellow;
	
	public Client() {
		
	}
	
	public Client(String name,GameBox boxFellow,GameBox boxMe) {
		try {
			Properties properties;
			InputStream inputStream;
			properties=new Properties();
			inputStream= new FileInputStream("res/config.ini");
			properties.load(inputStream);
			
			if(inputStream!=null)
				inputStream.close();			
			clientSocket = new Socket(
					properties.getProperty("server"),
					Integer.valueOf(properties.getProperty("port"))
				);
			this.boxMe=boxMe;
			this.boxFellow=boxFellow;
			this.myName=name;
			me=new PlayInfo();
			me.setName(name);
			new ReadThread().start();
			lastReadTime=Calendar.getInstance().getTime();
			sendMe(); //构造时发送自己以便在服务器注册自己。
			new CheckThread().start();
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}

	public String getName() {
		return myName;
	}

	public void setName(String name) {
		this.myName = name;
	}

	public Socket getSocket() {

		return null;
	}

	public void setSocket(Socket client) {

		
	}
	
	//向服务器发送自己的操作信息
	void writeMe() throws Exception{
		if(fellowName!=null)
			me.setFellowName(fellowName);
		
		//把fellow中的玩家数据复制出来
		//以下是方块数据
		me.px=boxMe.curshape.px-boxMe.px+boxFellow.px;
		me.py=boxMe.curshape.py;
		me.width=boxMe.curshape.width;
		me.l=boxMe.curshape.l;
		me.c=boxMe.curshape.c;
		
		for(int i=0;i<5;i++)
			for(int j=0;j<5;j++)
			{
				me.s[i][j] = boxMe.curshape.s[i][j];
				me.b[i][j] = boxMe.curshape.b[i][j];
			}
		
		//以下是玩家数据
		me.score=boxMe.score;
		me.level=boxMe.level;
		me.speed=boxMe.speed;
		me.layer=boxMe.layer;
		for(int i=0;i<41;i++)
			for(int j=0;j<22;j++)
			{
				me.stick[i][j] = boxMe.stick[i][j];
			}		
		
		os = new ObjectOutputStream(clientSocket.getOutputStream());
		os.writeObject(me);
		os.flush();
	}
	
	public void sendMe() {
		try {
			Log.debug("\nplayer "+myName+" write:\n" +me.toString());
			writeMe();
		} catch (Exception e) {
			Object o=e.getCause();
			if(e.getClass().getTypeName().contains("SocketException")) {
				if(e.getMessage().contains("Connection reset")) {
					try {
						System.out.println("server offline!");
						clientSocket.close();
					} catch (IOException e1) {
						e1.printStackTrace();
					}
				}
			}					
			e.printStackTrace();					
			try {
				Thread.sleep(5000);
			} catch (Exception e1) {
				e1.printStackTrace();
			}
		}
	}
	
	class CheckThread extends Thread {
		@Override
		public void run() {
			//检查队友是否掉线
			while (true) {
				Log.debug(lastReadTime.toLocaleString());
				if(lastReadTime!=null &&
						Calendar.getInstance().getTime().getTime()-lastReadTime.getTime()>10000) {
					fellowName=null;
					me.setFellowName(null);
				}
				try {
					Thread.sleep(10000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}//end of while				
		}//end of run()
	}
	
	
	
	class ReadThread extends Thread {
		@Override
		public void run() {
			// 不停的从服务器接收队友玩家操作信息
			while (true) {
				try {
					is = new ObjectInputStream(clientSocket.getInputStream());
					fellow = (PlayInfo) is.readObject();
					Log.debug("Player "+myName+" read:\n"+fellow.toString());
					if(fellow!=null)
						processFellow(fellow);
				} catch (Exception e) {
					if(fellow==null)
					{
						fellowName=null;
						fellow=null;
					}
					Object o=e.getCause();
					if(e.getClass().getTypeName().contains("SocketException")) {
						if(e.getMessage().contains("Connection reset")) {
							try {
								System.out.println("server offline!");
								clientSocket.close();
							} catch (IOException e1) {
								e1.printStackTrace();
							}			
						}				
						this.interrupt(); //当前线程终止
						break;
					}
					e.printStackTrace();
				}
			}//end of while
		}//end of run()
		
		//处理接收到的队友玩家操作信息
		void processFellow(PlayInfo fellow){
			lastReadTime=Calendar.getInstance().getTime();
			fellowName=fellow.getName();
			me.setFellowName(fellowName);
			boxFellow.setNickName(fellowName);
			//把fellow中的玩家数据复制出来
			//以下是方块数据
			boxFellow.curshape.px=fellow.px;
			boxFellow.curshape.py=fellow.py;
			boxFellow.curshape.width=fellow.width;
			boxFellow.curshape.l=fellow.l;
			boxFellow.curshape.c=fellow.c;
			
			for(int i=0;i<5;i++)
				for(int j=0;j<5;j++)
				{
					boxFellow.curshape.s[i][j] = fellow.s[i][j];
					boxFellow.curshape.b[i][j] = fellow.b[i][j];
				}
			
			//以下是玩家数据
			boxFellow.score=fellow.score;
			boxFellow.level=fellow.level;
			boxFellow.speed=fellow.speed;
			boxFellow.layer=fellow.layer;
			for(int i=0;i<41;i++)
				for(int j=0;j<22;j++)
				{
					boxFellow.stick[i][j] = fellow.stick[i][j];
				}
			
			boxFellow.play(1);
		}		
	}
}
