package com.zmofun.neterase.proto;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.Calendar;
import java.util.Date;

public class Client {
	private Socket clientSocket;
	private ObjectOutputStream os;
	private ObjectInputStream is;
	String myName;
	String fellowName;
	PlayInfo me;
	PlayInfo fellow;
	Date lastReadTime;
	
	public Client() {
		
	}
	
	public Client(String name) {
		try {
			clientSocket = new Socket("localhost", 8520);
			this.myName=name;
			me=new PlayInfo();
			me.setName(name);
			new ReadThread().start();
			new WriteThread().start();
			
			lastReadTime=Calendar.getInstance().getTime();
			new CheckThread().start();
		} catch (Exception e) {
			e.printStackTrace();
		}		
	}

	public String getName() {
		return myName;
	}

	public void setName(String name) {
		this.myName = name;
	}

	public Socket getSocket() {

		return null;
	}

	public void setSocket(Socket client) {

		
	}
	
	class CheckThread extends Thread {
		@Override
		public void run() {
			//检查队友是否掉线
			while (true) {
				//System.out.println(lastReadTime);
				if(lastReadTime!=null &&
						Calendar.getInstance().getTime().getTime()-lastReadTime.getTime()>10000) {
					fellowName=null;
					me.setFellowName(null);
					//System.out.println(lastReadTime);
				}
				try {
					Thread.sleep(5000);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}//end of while
		}//end of run()
		
		//向服务器发送自己的操作信息
		void writeMe() throws Exception{
			if(fellowName!=null)
				me.setFellowName(fellowName);
			os = new ObjectOutputStream(clientSocket.getOutputStream());
			os.writeObject(me);
			os.flush();
		}
		
	}
	
	
	
	class ReadThread extends Thread {
		@Override
		public void run() {
			// 不停的从服务器接收队友玩家操作信息
			while (true) {
				try {
					is = new ObjectInputStream(clientSocket.getInputStream());
					fellow = (PlayInfo) is.readObject();
					if(fellow!=null)
						processFellow(fellow);
				} catch (Exception e) {
					if(fellow==null)
					{
						fellowName=null;
						fellow=null;
					}
					Object o=e.getCause();
					if(e.getClass().getTypeName().contains("SocketException")) {
						if(e.getMessage().contains("Connection reset")) {
							try {
								System.out.println("server offline!");
								clientSocket.close();
							} catch (IOException e1) {
								e1.printStackTrace();
							}			
						}				
						this.interrupt(); //当前线程终止
						break;
					}
					e.printStackTrace();
				}				
			}//end of while
		}//end of run()
		
		//处理接收到的队友玩家操作信息
		void processFellow(PlayInfo fellow){
			System.out.println("player "+myName+" read:\n"+fellow.toString());
			lastReadTime=Calendar.getInstance().getTime();
			fellowName=fellow.getName();
			switch (fellow.getType()) {
				case 0: {					
					break;
				}
				default:{
					break;
				}
			}			
		}		
	}
	
	class WriteThread extends Thread {
		@Override
		public void run() {
			// 不停的向服务器发送自己的操作信息
			while (true) {
				try {
					System.out.println("\nplayer "+myName+" write:\n" +me.toString());
					writeMe();
					Thread.sleep(5000);
				} catch (Exception e) {
					Object o=e.getCause();
					if(e.getClass().getTypeName().contains("SocketException")) {
						if(e.getMessage().contains("Connection reset")) {
							try {
								System.out.println("server offline!");
								clientSocket.close();
							} catch (IOException e1) {
								e1.printStackTrace();
							}
						}
						this.interrupt(); //当前线程终止
						break;
					}					
					e.printStackTrace();					
					try {
						Thread.sleep(5000);
					} catch (Exception e1) {
						e1.printStackTrace();
					}
				}
					
			}//end of while
		}//end of run()
		
		//向服务器发送自己的操作信息
		void writeMe() throws Exception{
			if(fellowName!=null)
				me.setFellowName(fellowName);
			os = new ObjectOutputStream(clientSocket.getOutputStream());
			os.writeObject(me);
			os.flush();
		}
		
	}

}

